/*
**   MidiPlayer fuer private Homepages
**
**     @Version: 1.9
**     @Autor: Thomas Meyer
**     @Mail: tom@all-community.de
**
*/

music = new Array();
var selectedSong=0; // gewhlter Song
var selectedVolume=0; // gewhlte Lautstrke
var selectedBalance=0; // gewhlte Balance
var fading=true; // Fade-In, Fade-Out an/aus
var introDelay=8000; /* Zahl der Millisekunden, die jeder Titel
                        im Intro-Modus angespielt werden soll */
var version="midi.PLAYER 1.9";
var fxTimer = null;
var timer = null;
var readyTimer = null;
var fadeTimer = null;
var text;
var ready = true;

function song(titel, url, download) {
  var i = music.length;
  music[i] = new Object();
  music[i].TITEL    = titel;
  music[i].URL      = url;
  music[i].DOWNLOAD = download;
};

song("Musik AUS", "", "nein");

function button(number) {
  if (readyTimer != null) { window.clearTimeout(readyTimer); };
  if (parseInt(number) == NaN) { return false;
  } else {
      if (!ready) {
        document.form.sound.value += number;
      } else {
        ready = false;
        document.form.sound.value  = number;
      };
      readyTimer = window.setTimeout("playMusic()",3000);
  };
};

function next() {
  if (selectedSong < music.length-1) {
      ++selectedSong;
      document.form.sound.value = selectedSong;
      playMusic();
  } else { };
};

function previous() {
  if (selectedSong > 1) {
      --selectedSong;
      document.form.sound.value = selectedSong;
      playMusic();
  } else { };
};

function stopMusic() {
  if (readyTimer != null) { window.clearTimeout(readyTimer); };
  document.form.sound.value = "";
  ready = true;
  selectedSong = 0; // Titel 0 enthlt Pseudotitel, der Musik abschaltet
  play();
  showMsg("Stopp");
};

function playMusic() {
  if (readyTimer != null) { window.clearTimeout(readyTimer); };
  ready = true;
  var user_selection = parseInt(document.form.sound.value);
  document.form.sound.value = "";
  if (user_selection > 0 && user_selection < music.length) {
      selectedSong = user_selection;
      play();
      showMsg(selectedSong+' / '+(music.length-1));
  }
  else {
      showMsg("kein Titel");
  };
};

function play() {
  document.form.info.value = ">> "+music[selectedSong].TITEL+" <<          ";
  if (fading) { fadeInOut(-1000, 10); };
  bgSound.src= music[selectedSong].URL;
};

//****************************************************************************************//

function loop() {
  if (bgSound.loop == 0) { bgSound.loop = -1; showMsg("loop AN");
  } else { bgSound.loop = 0; showMsg("loop AUS"); };
};


//****************************************************************************************//

function volume(volume) {
  var oldVolume = selectedVolume;
  selectedVolume = volume;
  if (fading) { fadeInOut(oldVolume, 4);
  } else { bgSound.volume = volume; };
};

function fadeInOut(begin, step) {
  if (fadeTimer != null) { window.clearTimeout(fadeTimer); };
  if (begin < selectedVolume && step < 0) { step = - step;
  } else if (begin > selectedVolume && step > 0) { step = - step; };
  bgSound.volume = begin;
  fader(step);
};

function fader(step) {
  if (bgSound.volume > selectedVolume) { bgSound.volume -= Math.round(Math.sqrt(Math.abs(bgSound.volume - selectedVolume))) + 10;
  } else { bgSound.volume += Math.round(Math.sqrt(Math.abs(bgSound.volume - selectedVolume))) + 10; };
  if (Math.abs(bgSound.volume - selectedVolume) + 10 >= 50) {
    fadeTimer = window.setTimeout('fader('+step+')', step);
  } else {
    bgSound.volume = selectedVolume;
  };
};

//****************************************************************************************//

function balance(balance) {
  selectedBalance = balance;
  bgSound.balance = balance;
};

// <!.. Special-Effect Balance-Shift: 0->links->rechts->0

function fxBalanceShift() {
  if (fxTimer == null) { // wenn aus -> anschalten
    showMsg("fx AN");
    swingLeft(-1000, selectedBalance);
  } else { // sonst -> ausschalten
    showMsg("fx AUS");
    window.clearTimeout(fxTimer);
    balance(selectedBalance);
    fxTimer = null;
  };
};

/* Hilfsfunktion */
function swingLeft(ziel, i) {
  bgSound.balance = i;
  i -= 20;
  if (i > ziel - 10) { fxTimer = window.setTimeout('swingLeft('+ ziel + ', ' + i +')', 10);
  } else if (ziel != 0) { swingRight(1000, i);
  } else { };
};

/* Hilfsfunktion */
function swingRight(ziel, i) {
  bgSound.balance = i;
  i += 20;
  if (i < ziel + 10) { fxTimer = window.setTimeout('swingRight('+ ziel + ', '+ i +')', 10);
  } else if (ziel != 0) { swingLeft(-1000, i);
  } else { };
};

//..>

//****************************************************************************************//

function introModus() {
  showMsg('Intro');
  selectedSong = 1;
  playIntro();
};

function playIntro() {
  play();
  if (selectedSong < music.length -1) {
    selectedSong++;
    readyTimer = window.setTimeout('playIntro()', introDelay);
  } else {
    selectedSong = 0;
    readyTimer = window.setTimeout('play()', introDelay);
  };
};

//****************************************************************************************//

function playlist() {
  var playlistSeite = window.open("", "playlist", "width=260, height=380, scrollbars=1");
  with (playlistSeite.document) {
    clear();
    writeln('\n<html>\n<head>\n  <title>Playlist</title>\n</head>\n\n<body oncontextmenu="return false" link="orange" vlink="orange" alink="orange" bgColor="darkred" text="white">\n');
    writeln('<style>');
    writeln('  P  { FONT-SIZE: 10pt; MARGIN: 10pt }');
    writeln('  TT { FONT-SIZE: 11pt; FONT-WEIGHT: bold; COLOR: orange }');
    writeln('  INPUT { FONT-SIZE: 9pt; FONT-WEIGHT: bold; COLOR: orange; background-color: gray; border: 2 outset orange }');
    writeln('</style>');
    writeln('  <font face="Arial, Helvetica">');
    writeln('  <div onselectstart="return false">');
    writeln('<H3>Playlist</H3>');
    for (var i=1; i < music.length; i++) {
      writeln('<P><TT>'+i+'&nbsp;</TT>'+music[i].TITEL+'</P>');
    };
    writeln('  <FORM name="playlist"></FORM>');
    writeln('<H3>Titel hinzufgen</H3>');
    writeln('  </div>');
    writeln('  <FORM name="form" onsubmit="player.addSong(document.form.titel.value,(document.form.datei.value).replace(/\\\\/gi, \'\\/\')); document.playlist.innerHTML+=\'<P><TT>\'+(player.music.length -1)+\'&nbsp;</TT>\'+document.form.titel.value+\'</P>\'; return false"><P><input size="5" name="datei" id="datei" type="file"><P><input name="titel" id="titel" type="text" value="Titel"><input type="submit" value="OK">');
    writeln('  </FORM>');
    writeln('  </font>');
    writeln('</body>\n</html>');
    close();
  };
  playlistSeite.player = this;

  playlistSeite.focus();
};

function aboutPlayer(player) {
  var infoSeite = window.open("", "Info", "width=350, height=500, scrollbars=1");
  with (infoSeite.document) {
    clear();
    writeln('\n<html>\n<head>\n  <title>Info</title>\n</head>\n\n<body link="orange" vlink="orange" alink="orange" bgColor="darkred" text="white">\n');
    writeln('<style>');
    writeln('  A:HOVER { color: antiquewhite }');
    writeln('  P       { FONT-SIZE: 10pt; MARGIN: 10pt }');
    writeln('  UL      { FONT-SIZE: 11pt; COLOR: orange; FONT-WEIGHT: bold }');
    writeln('</style>');
    writeln('  <font face="Arial, Helvetica">');
    writeln('<DIV align=justify>');
    writeln('<H3>'+version+'</H3>');
    writeln('<H4>&Uuml;ber uns ...</H4>');
    writeln('<P>Der midi.Player ist eine grafische Oberflche zum Abspielen von Sounddateien im Netz');
    writeln('und wird von <a href="http://www.all-community.de" target="_blank">All-Community.de</a> in mehreren');
    writeln('Versionen und verschiedenen Skins (fr Privatpersonen) zum kostenlosen Download angeboten.</P>');
    writeln('<P>Unerlaubte Weitergabe, insbesondere Verkauf oder kommerzielle Verwendung ist nicht gestattet. Und natrlich drfen sie auch nur dann Musik damit abspielen, wenn sie dabei keine Urheberrechte Dritter verletzen. ;o)</P>');
    writeln('<P>Wenn sie auch einen Player fr ihre eigene Homepage mchten, klicken sie');
    writeln('<a href="http://www.all-community.de/beispiele/midiplayer/" target="_blank">hier</a>.');
    writeln('Fragen zu diesem Player? Mail gengt.</P>');
    writeln('<P><strong>Autor:</strong> Thomas Meyer');
    writeln('<BR> <strong>Home:</strong> <a href="http://www.all-community.de" target="_blank">www.All-Community.de</a>');
    writeln('<BR> <strong>Mail:</strong> <a href="mailto:support@all-community.de" target="_blank">support@All-Community.de</a></p>');
    writeln('<H4>Online-Hilfe ...</H4>');
    writeln('<UL>\n<LI>Browser-Kompatibilitt</LI>\n</UL>');
    writeln('<P>Dieser Player ist nicht kompatibel zu Netscape Navigator oder Opera</P>');
    writeln('<UL>\n<LI>Funktionsweise</LI>\n</UL>');
  };

  switch (player) {
    case 'standard':
      hilfe(infoSeite.document);
      break;
    case 'XL':
      hilfe(infoSeite.document);
      hilfeXL(infoSeite.document);
      break;
    case 'XXL':
      hilfe(infoSeite.document);
      hilfeXL(infoSeite.document);
      hilfeXXL(infoSeite.document);
      break;
  };

  with (infoSeite.document) {
    writeln('<H4>Haftungsausschluss</H4>');
    writeln('<P>Sie benutzen diesen Player auf eigene Gefahr. Sollten sie sich dabei k&ouml;rperliche oder seelische Sch&auml;den oder sonstigen Schaden an was auch immer mit diesem Player in Kontakt kommt zuziehen, verweigern wir jegliche Haftung.');
    writeln('Sollten sie w&auml;hrend der Arbeit mit diesem Player Schwindel, Kopfschmerzen oder sonstiges Unwohlsein versp&uuml;hren, schalten sie den Rechner sofort ab und benutzen sie das Produkt ohne ausdr&uuml;ckliche Erlaubnis ihres Arztes nicht mehr.');
    writeln('F&uuml;r die angebotenen Titel (inklusive deren Qualit&auml;t und Herkunft) sind wir nicht verantwortlich. Wir &uuml;bernehmen keine Haftung, falls mit Hilfe dieses Players gegen die Urheberrechte Dritter verstossen wird. In diesem Fall wenden sie sich bitte direkt an den Webmaster der Seite, die diesen Player einsetzt.');
    writeln('<HR><P>&copy; Thomas Meyer (www.All-Community.de) 2002</P>');
    writeln('</DIV>');
    writeln('  </font>')
    writeln('</body>\n</html>');
    close();
  };

  infoSeite.focus();
};

function hilfe(target) {
  target.writeln('<P><img src="button_0.jpg">&nbsp;<strong><i>bis</i></strong>&nbsp;<img src="button_9.jpg">&nbsp;Mit diesen Kn&ouml;pfen');
  target.writeln('k&ouml;nnen sie die Nummer des Titel eingeben, den sie gern h&ouml;ren m&ouml;chten.');
  target.writeln('<P><img src="button_enter.jpg">&nbsp;Wenn sie die Nummer ihres Wunschtitels eingegeben haben,');
  target.writeln('starten sie mit dieser Taste die Wiedergabe.');
  target.writeln('<P><img src="button_back.jpg">&nbsp;<img src="button_next.jpg">&nbsp;Mit diesen Schaltern k&ouml;nnen sie');
  target.writeln('einen Titel zur&uuml;ck oder vor springen.');
  target.writeln('<P><img src="button_stop.jpg">&nbsp;Hier schalten sie die Musik ab.');
  target.writeln('<P><img src="button_eject.jpg">&nbsp;Wenn ihnen ein Titel gefallen hat und der Autor der Seite das gestattet,');
  target.writeln('&ouml;ffnet sich bei Klick auf diesen Schalter ein Pop-Up Fenster mit dem Link zum Download der Datei.');
};

function hilfeXL(target) {
  target.writeln('<UL>\n<LI>weitere Funktionen</LI>\n</UL>');
  target.writeln('<P><STRONG>Lautst&auml;rke</STRONG>&nbsp;<img src="volume.jpg">&nbsp;Der Player verf&uuml;gt &uuml;ber einen');
  target.writeln('graphischen Lautst&auml;rkeregler. Hier k&ouml;nnen sie einstellen');
  target.writeln('wie laut oder leise die Wiedergabe sein soll. Klicken sie auf den gr&uuml;nen Bereich um');
  target.writeln('den Ton leiser, oder auf den roten Bereich um ihn lauter zu machen.');
  target.writeln('<P><STRONG>Balance</STRONG>&nbsp;<img src="balance.jpg">&nbsp;&Uuml;ber diesen Balanceregler');
  target.writeln('k&ouml;nnen sie das Gewicht der Wiedergabe zwischen linkem und rechtem Kanal variieren.');
  target.writeln('Praktisch, falls sie das Gef&uuml;hl haben, dass die Musik nur von rechts bzw. links zu kommen scheint.');
  target.writeln('Wenn sie in die Mitte klicken ist die Balance zwischen links und rechts ausgeglichen.');
  target.writeln('<P><img src="button_playlist.jpg">&nbsp;&Oumlffnet ein Fenster mit einer &Uuml;bersicht aller Titel.');
  target.writeln('<P><img src="button_info.jpg">&nbsp;&Ouml;ffnet diese Hilfeseite.');
};

function hilfeXXL(target) {
  target.writeln('<P><img src="button_intro.jpg">&nbsp;Startet den Intro-Modus. Im Intro-Modus werden alle Titel nacheinander kurz angespielt, damit sie schneller finden, was ihnen gef&auml;llt.');
  target.writeln('<P><img src="button_loop.jpg">&nbsp;Damit schalten sie die Wiederholung des aktuellen Titels ein oder aus. Bei Aktivierung wird der gerade aktuelle Titel endlos wiederholt.');
  target.writeln('<P><img src="button_fx.jpg">&nbsp;Aktiviert oder deaktiviert Balance-Shifting. Dieser Special-Effect l&auml;sst das Zentrum der Balance zwischen linkem und rechtem Kanal schwenken um einen 3D-Effekt zu erzeugen.');
};

function showMsg(text) {
  if (readyTimer != null) { window.clearTimeout(readyTimer); };
  document.form.sound.value = text;
  readyTimer = setTimeout("document.form.sound.value=''", 2000);
};

function downloadMusic() {
  if (music[selectedSong].DOWNLOAD == "ja") {
    var download = window.open("about:blank", "Download", "width=350, height=100");
    download.document.clear();
    download.document.writeln('<html><head><title>Download</title></head><body link="#FF0000" vlink="#FF0000" alink="#FFA000" bgColor="darkred" text="white"><p align="center"><font face="Arial, Helvetica">'+music[selectedSong].TITEL+'</p><p align="center"><i><a href="'+music[selectedSong].URL+'">jetzt downloaden!</a></i></font></p></body></html>');
    download.document.close();
  }
  else {
      alert("Der Download dieser Datei ist nicht gestattet.");
  };
};

//****************************************************************************************//

function refresh()
{
    clearTimeout(timer);
    scroll();
};

function scroll()
{
    info  = document.form.info.value;
    info  = info.substring(1, info.length) + info.substring(0,1);
    document.form.info.value = info;
    var timer = setTimeout("refresh();", 100);
};

//  2002, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
